个人心得:这在一定途径上完成查询方面还是很吃力,得多锻炼空间能力,不能再每次都看到就后退,要全力应对,

那怕被虐的不要不要的。

这题主要是求俩个端点中所有路径中最大构成的集合中最小的数值,其实开始思想已经到触及到了这一块,

就想着从一直衍生每次都是max更新,但最终点那里还是卡了一下,还有自己的算法很容易就被突兀的途径给打乱了。

Floyd算法挺不错的,进行一点点的改变就好了,他就是保存每个端点中的最大值的最小值,你想呀,你如果到一个端点,其实在

延伸的时候就已经得到了这条途径的最大值了,比如5端点,你可以从1-3,3-5,则你判断的时候就只要将1-3端点的最大值和3-5端点

的值进行对比就得到了,此时再与5端点所存在的最大值比较就好了

核心算法就是

1 for(int k=1;k<=x;k++)
2             for(int i=1;i<=x;i++)
3                 for(int j=1;j<=x;j++)
4                     if(decibel[i][k]!=inf&&decibel[k][j]!=inf)
5                    decibel[i][j]=min(decibel[i][j],max(decibel[i][k],decibel[k][j]));

Consider yourself lucky! Consider yourself lucky to be still breathing and having fun participating in this contest. But we apprehend that many of your descendants may not have this luxury. For, as you know, we are the dwellers of one of the most polluted cities on earth. Pollution is everywhere, both in the environment and in society and our lack of consciousness is simply aggravating the situation. However, for the time being, we will consider only one type of pollution - the sound pollution. The loudness or intensity level of sound is usually measured in decibels and sound having intensity level 130 decibels or higher is considered painful. The intensity level of normal conversation is 6065 decibels and that of heavy traffic is 7080 decibels. Consider the following city map where the edges refer to streets and the nodes refer to crossings. The integer on each edge is the average intensity level of sound (in decibels) in the corresponding street. To get from crossing A to crossing G you may follow the following path: A-C-F-G. In that case you must be capable of tolerating sound intensity as high as 140 decibels. For the paths A-B-E-G, A-B-D-G and A-C-F-D-G you must tolerate respectively 90, 120 and 80 decibels of sound intensity. There are other paths, too. However, it is clear that A-C-F-D-G is the most comfortable path since it does not demand you to tolerate more than 80 decibels. In this problem, given a city map you are required to determine the minimum sound intensity level you must be able to tolerate in order to get from a given crossing to another. Input The input may contain multiple test cases. The first line of each test case contains three integers C(≤ 100), S(≤ 1000) and Q(≤ 10000) where C indicates the number of crossings (crossings are numbered using distinct integers ranging from 1 to C), S represents the number of streets and Q is the number of queries. Each of the next S lines contains three integers: c1, c2 and d indicating that the average sound intensity level on the street connecting the crossings c1 and c2 (c1 ̸= c2) is d decibels. Each of the next Q lines contains two integers c1 and c2 (c1 ̸= c2) asking for the minimum sound intensity level you must be able to tolerate in order to get from crossing c1 to crossing c2. The input will terminate with three zeros form C, S and Q. Output For each test case in the input first output the test case number (starting from 1) as shown in the sample output. Then for each query in the input print a line giving the minimum sound intensity level (in decibels) you must be able to tolerate in order to get from the first to the second crossing in the query. If there exists no path between them just print the line “no path”. Print a blank line between two consecutive test cases.

Sample Input

7 9 3

1 2 50

1 3 60

2 4 120

2 5 90

3 6 50

4 6 80

4 7 70

5 7 40

6 7 140

1 7

2 6

6 2

7 6 3

1 2 50

1 3 60

2 4 120

3 6 50

4 6 80

5 7 40

7 5

1 7

2 4

0 0 0

Sample Output

Case #1

80 60 60

Case #2

40 no path 80

 1 #include<iostream>
 2 #include<cstdio>
 3 #include<cmath>
 4 #include<cstring>
 5 #include<iomanip>
 6 #include<algorithm>
 7 using namespace std;
 8 const long long inf=9999999;
 9 int x,y,z;;
10 int decibel[105][105];
11 void init()
12 {
13     for(int i=1;i<=x;i++)
14         for(int j=1;j<=x;j++)
15           if(i==j) decibel[i][j]=0;
16          else decibel[i][j]=inf;
17
18 }
19 int main()
20 {
21      int flag=1;
22     while(cin>>x>>y>>z)
23     {
24
25         if(!x&&!y&&!z) break;
26         init();
27        for(int i=1;i<=y;i++)
28        {
29            int m,n,q;
30            scanf("%d%d%d",&m,&n,&q);
31            if(decibel[m][n]>q)
32                 decibel[m][n]=decibel[n][m]=q;
33
34        }
35        if(flag>1) cout<<endl;
36         for(int k=1;k<=x;k++)
37             for(int i=1;i<=x;i++)
38                 for(int j=1;j<=x;j++)
39                     if(decibel[i][k]!=inf&&decibel[k][j]!=inf)
40                    decibel[i][j]=min(decibel[i][j],max(decibel[i][k],decibel[k][j]));
41                    cout<<"Case #"<<flag++<<endl;
42        for(int i=1;i<=z;i++)
43        {
44            int m,n;
45            scanf("%d%d",&m,&n);
46            if(decibel[m][n]!=inf)
47            cout<<decibel[m][n]<<endl;
48            else
49             cout<<"no path"<<endl;
50
51        }
52     }
53     return 0;
54 }

转载于:https://www.cnblogs.com/blvt/p/7347855.html

Audiophobia(Floyd算法)相关推荐

  1. uva 10048 噪音恐惧症 Audiophobia Floyd算法

    ljr的书里说错了,套Floyd算法的模板是,加改为max, min还是min. 还有就是ljr的if(d[i][j] < INF && d[k][j] < INF)明显是 ...

  2. Uvaoj 10048 - Audiophobia(Floyd算法变形)

    1 /* 2 题目大意: 3 从一个点到达另一个点有多条路径,求这多条路经中最大噪音值的最小值! . 4 5 思路:最多有100个点,然后又是多次查询,想都不用想,Floyd算法走起! 6 */ 7 ...

  3. 数据结构与算法(7-4)最短路径(迪杰斯特拉(Dijkstra)算法、弗洛伊德(Floyd)算法)

    目录 一.最短路径概念 二.迪杰斯特拉(Dijkstra)算法(单源最短路径) 1.原理 2.过程 3.代码 三.弗洛伊德(Floyd)算法(多源最短路径) 1.原理 2.存储 3.遍历 4.代码 参 ...

  4. 【POJ/算法】 3259 Wormholes(Bellman-Ford算法, SPFA ,FLoyd算法)

    Bellman-Ford算法 Bellman-Ford算法的优点是可以发现负圈,缺点是时间复杂度比Dijkstra算法高.而SPFA算法是使用队列优化的Bellman-Ford版本,其在时间复杂度和编 ...

  5. 最小环算法求解(Dijkstra算法+Floyd算法)

    方法一: #include<iostream> #include<algorithm> #include<cmath> #include<cstdio> ...

  6. HDU2544(Bellman-ford算法和Floyd算法)

    思路: 1.初始化时将起点 s 到各个顶点 v 的距离 dist(s->v) 赋值为 ∞,dist(s->s) 赋值为 0: 2.后续进⾏最多 n-1 次遍历操作 (n 为顶点个数), 对 ...

  7. 【图论专题】Floyd算法及其扩展应用

    Floyd的拓展应用: 任意两点最短路 传递闭包 找最小环 恰好经过k条边的最短路(倍增) 题目列表: 题目 算法 AcWing 1125. 牛的旅行 任意两点最短路Floyd AcWing 343. ...

  8. 【图论】用一道题从本质上讲清楚Floyd算法

    P1119 [灾后重建] 4 5 1 2 3 4 0 2 1 2 3 1 3 1 2 2 1 4 0 3 5 4 2 0 2 0 1 2 0 1 3 0 1 4 -1 -1 5 4 一道非常好的Flo ...

  9. 图的单源最短路径,Floyd算法(数据结构c++)

    这个算法结构很是简单,但是理解还是有一定的困难,一开始做的时候想不明白,跟着算法自己动手画画就知道这个算法具体是怎么回事了. 时间复杂度是O(N*3) 算法有点动态规划的意思,有两个数组,一个(dis ...

  10. floyd算法_最短路径的算法:Floyd算法

    点击箭头处"蓝色字",关注我们哦!! 算法 最短路径的算法-Floyd算法 ● ○ ● Shortest Path Algorithm - Floyd Algorithm ● ○ ...

最新文章

  1. 一文看懂机器视觉芯片 ​
  2. 第11章 PADS功能使用技巧(2)-最全面
  3. 经过阿里,百度一面,二面后,我总结了150道iOS面试题
  4. Linux中的docker top命令
  5. 苹果Mac最好用的记事本工具:Ulysses
  6. 整数转字符串,字符串转整数
  7. 程序设计实践之车辆信息管理系统
  8. Basic 语言发展史
  9. 将多个Bip动作合成一个
  10. 将MongoDB安装在移动硬盘
  11. avue一些隐藏的配置
  12. Six提供了Python 2和Python 3的兼容库
  13. 2021年网站不备案还会有收录排名吗
  14. 2021Java最新技术发展趋势
  15. 提升源代码安全管控,从源头保护敏感数据
  16. open_files打开输入输出文件
  17. java关闭ftp 连接_Java语言实现简单FTP软件------gt;连接管理模块的实现:主机与服务器之间的连接与关闭操作(八) - 移动编程 - ITeye博客...
  18. 草稿-9206-盒子模型-
  19. 计算RC电路电容充电时间
  20. Android 9.0 安装包解析错误

热门文章

  1. Innosetup打包自动下载.net framework 动态库及替换卸载程序图标.
  2. 不负高端商务旗舰之名,金立M2017将搭载高通芯片
  3. 微信公众平台可为市民鉴别万余药品真伪
  4. Oracle RMAN完全恢复案例(二)
  5. Web 设计师的 50 个超便利工具[下]
  6. 学习Linux的七点忠告
  7. 通过Java技术手段,某程序员发现自己被绿了!
  8. 同学,你要的SpringBoot多图片上传回显功能已经实现了,赶紧收藏吃灰~
  9. 使用 Redis 实现一个轻量级的搜索引擎,牛逼啊!
  10. 重磅!!Redis 6.0.0 已发布,有史以来改变最大的版本